/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version: 1.3.21
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package org.osgeo.mapguide;



/**
 * Manipulates collections of {@link MgdMapPlot} objects.
 *
 */
 public class MgdMapPlotCollection extends MgSerializable {
  private long swigCPtr;

  public MgdMapPlotCollection(long cPtr, boolean cMemoryOwn) {
    super(MapGuideDesktopApiJNI.SWIGMgdMapPlotCollectionToMgSerializable(cPtr), cMemoryOwn);
    swigCPtr = cPtr;
  }

  protected void finalize() {
    delete();
  }

  public void delete() {
    if(swigCPtr != 0 && swigCMemOwn) {
      swigCMemOwn = false;
      MapGuideDesktopApiJNI.delete_MgdMapPlotCollection(swigCPtr);
    }
    swigCPtr = 0;
    super.delete();
  }

  protected static long getCPtr(MgdMapPlotCollection obj) {
    return (obj == null) ? 0 : obj.swigCPtr;
  }

  
/**
 * Gets the number of MapPlots in the collection.
 *
 * @return  Returns the number of MapPlots.
 */
 public int getCount() {
    return MapGuideDesktopApiJNI.MgdMapPlotCollection_GetCount(swigCPtr);
  }

  
/**
 * Gets the MapPlot at the specified index.
 *
 * @param  index (int)  Index of the map to get.
 * @return  Returns the specified {@link MgdMapPlot} object.
 * @exception  MgOutOfRangeException if the index is invalid.
 */
 public MgdMapPlot getItem(int index) {
    long cPtr = MapGuideDesktopApiJNI.MgdMapPlotCollection_GetItem__SWIG_0(swigCPtr, index);
    return (cPtr == 0) ? null : (MgdMapPlot)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Gets the MapPlot with the specified name.
 *
 * @param  name (String/string)  Name of the MapPlot to get.
 * @return  Returns the specified {@link MgdMapPlot} object.
 * @exception  MgInvalidArgumentException if the name does not exist in
 */
 public MgdMapPlot getItem(String name) {
    long cPtr = MapGuideDesktopApiJNI.MgdMapPlotCollection_GetItem__SWIG_1(swigCPtr, name);
    return (cPtr == 0) ? null : (MgdMapPlot)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Sets the MapPlot in the collection at the specified index to a
 * specified value.
 *
 * @param  index (int)  Position in the collection to set the  {@link MgMapPot}.
 * @param  value ({@link MgdMapPlot})  {@link MgdMapPlot} to be set in the collection.
 * @return  Returns nothing.
 * @exception  MgOutOfRangeException if the index is out of range.
 */
 public void setItem(int index, MgdMapPlot value) {
    MapGuideDesktopApiJNI.MgdMapPlotCollection_SetItem(swigCPtr, index, MgdMapPlot.getCPtr(value));
  }

  
/**
 * Adds the specified MapPlot to the end of the collection.
 *
 * @param  value ({@link MgdMapPlot})  {@link MgdMapPlot} to be added to the collection.
 * @return  Returns nothing.
 */
 public void add(MgdMapPlot value) {
    MapGuideDesktopApiJNI.MgdMapPlotCollection_Add(swigCPtr, MgdMapPlot.getCPtr(value));
  }

  
/**
 * Inserts a MapPlot at a specified index within the collection.
 *
 * @param  index (int)  Position in the collection to insert the  {@link MgdMapPlot}.
 * @param  value ({@link MgdMapPlot})  {@link MgdMapPlot} to be inserted in the collection.
 * @return  Returns nothing.
 * @exception  MgOutOfRangeException if the specified index is out of
 */
 public void insert(int index, MgdMapPlot value) {
    MapGuideDesktopApiJNI.MgdMapPlotCollection_Insert(swigCPtr, index, MgdMapPlot.getCPtr(value));
  }

  
/**
 * Removes all MapPlots from the collection.
 *
 * @return  Returns nothing.
 */
 public void clear() {
    MapGuideDesktopApiJNI.MgdMapPlotCollection_Clear(swigCPtr);
  }

  
/**
 * Removes a MapPlot from the collection.
 *
 * @param  value ({@link MgdMapPlot})  {@link MgdMapPlot} to be removed
 * @return  Returns true if removal was successful.
 */
 public boolean remove(MgdMapPlot value) {
    return MapGuideDesktopApiJNI.MgdMapPlotCollection_Remove(swigCPtr, MgdMapPlot.getCPtr(value));
  }

  
/**
 * Removes a MapPlot from the collection at the specified index.
 *
 * @param  index (int)  Index of the map to be removed.
 * @return  Returns nothing.
 * @exception  MgOutOfRangeException if the MapPlot does not exist in the
 */
 public void removeAt(int index) {
    MapGuideDesktopApiJNI.MgdMapPlotCollection_RemoveAt(swigCPtr, index);
  }

  
/**
 * Determines if the collection contains the specified MapPlot.
 *
 * @param  name (String/string)  Name of the MapPlot.
 * @return  Returns true if the collection contains the specified map,
 *  or false otherwise.
 */
 public boolean contains(String name) {
    return MapGuideDesktopApiJNI.MgdMapPlotCollection_Contains__SWIG_0(swigCPtr, name);
  }

  
/**
 * Determines if the collection contains the specified MapPlot.
 *
 * @param  value ({@link MgdMapPlot})  The {@link MgdMapPlot} to look for.
 * @return  Returns true if the collection contains the specified MapPlot,
 *  or false otherwise.
 */
 public boolean contains(MgdMapPlot value) {
    return MapGuideDesktopApiJNI.MgdMapPlotCollection_Contains__SWIG_1(swigCPtr, MgdMapPlot.getCPtr(value));
  }

  
/**
 * Gets the index of the specified MapPlot in the collection.
 *
 * @param  name (String/string)  Name of the MapPlot to get the index of.
 * @return  Returns the MapPlot's index if the collection contains the
 *  specified MapPlot, or false (-1) otherwise.
 */
 public int indexOf(String name) {
    return MapGuideDesktopApiJNI.MgdMapPlotCollection_IndexOf__SWIG_0(swigCPtr, name);
  }

  
/**
 * Gets the index of the specified MapPlot in the collection.
 *
 * @param  value ({@link MgdMapPlot})  Value of the item to get the index of.
 * @return  Returns the MapPlot's index if the collection contains the
 *  specified MapPlot, or false (-1) otherwise.
 */
 public int indexOf(MgdMapPlot value) {
    return MapGuideDesktopApiJNI.MgdMapPlotCollection_IndexOf__SWIG_1(swigCPtr, MgdMapPlot.getCPtr(value));
  }

  
/**
 * Constructs an empty {@link MgdMapPlotCollection} object.
 *
 */
 public MgdMapPlotCollection() {
    this(MapGuideDesktopApiJNI.new_MgdMapPlotCollection(), true);
  }

}
